unit Preview;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, PrevBox;

type
  TPreviewForm = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Panel2: TPanel;
    Panel3: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    PreviewBox1: TPreviewBox;
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure PreviewBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Panel2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private 錾 }
    procedure CheckButtons;
  public
    { Public 錾 }
    procedure Starting;
  end;

var
  PreviewForm: TPreviewForm;

implementation

uses Frame;

{$R *.DFM}

procedure TPreviewForm.Button3Click(Sender: TObject);
begin
  PreviewBox1.StartPage := PreviewBox1.StartPage - PreviewBox1.Partition;
  CheckButtons;
end;

procedure TPreviewForm.Button4Click(Sender: TObject);
begin
  PreviewBox1.StartPage := PreviewBox1.StartPage + PreviewBox1.Partition;
  CheckButtons;
end;

procedure TPreviewForm.PreviewBox1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then
    PreviewBox1.Ratio := PreviewBox1.Ratio + 10
  else if Button = mbLeft then
    PreviewBox1.Ratio := PreviewBox1.Ratio - 10;
end;

procedure TPreviewForm.Button1Click(Sender: TObject);
var
  i: Integer;
begin
  if FrameForm.PrintDialog1.Execute then
  begin
    if RadioButton1.Checked then
      PreviewBox1.Print(FrameForm.PrintDialog1.Copies)
    else
    begin
      i := PreviewBox1.StartPage + PreviewBox1.ImageCount * PreviewBox1.Partition - 1;
      if i > PreviewBox1.PageCount then
        i := PreviewBox1.PageCount;
      PreviewBox1.PrintPage(PreviewBox1.StartPage, i, FrameForm.PrintDialog1.Copies);
    end;
  end;
end;

procedure TPreviewForm.Panel2MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then
    PreviewBox1.Column := PreviewBox1.Column + 1
  else if Button = mbLeft then
    PreviewBox1.Column := PreviewBox1.Column - 1;
  Panel2.Caption := ' = ' + IntToStr(PreviewBox1.Column);
  CheckButtons;
end;

procedure TPreviewForm.Panel3MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then
    PreviewBox1.Row := PreviewBox1.Row + 1
  else if Button = mbLeft then
    PreviewBox1.Row := PreviewBox1.Row - 1;
  Panel3.Caption := 's = ' + IntToStr(PreviewBox1.Row);
  CheckButtons;
end;

procedure TPreviewForm.CheckButtons;
begin
  if PreviewBox1.StartPage > PreviewBox1.Partition then
    Button3.Enabled := True
  else
    Button3.Enabled := False;
  if PreviewBox1.StartPage + PreviewBox1.ImageCount
   * PreviewBox1.Partition <= PreviewBox1.PageCount then
    Button4.Enabled := True
  else
    Button4.Enabled := False;
  if PreviewBox1.PageCount <= PreviewBox1.ImageCount * PreviewBox1.Partition  then
  begin
    RadioButton1.Checked := True;
    RadioButton1.Enabled := False;
    RadioButton2.Enabled := False;
  end
  else
  begin
    RadioButton1.Enabled := True;
    RadioButton2.Enabled := True;
  end;
end;

procedure TPreviewForm.FormShow(Sender: TObject);
begin
  ClientWidth := PreviewBox1.ImageWidth * PreviewBox1.Column + 5;
  ClientHeight := PreviewBox1.ImageHeight * PreviewBox1.Row + 50;
  Panel2.Caption := ' = ' + IntToStr(PreviewBox1.Column);
  Panel3.Caption := 's = ' + IntToStr(PreviewBox1.Row);
  FrameForm.PrintDialog1.Options := [];
  Starting;
end;

procedure TPreviewForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  FrameForm.PrintDialog1.Options := [poPageNums, poSelection];
end;

procedure TPreviewForm.Starting;
begin
  if Caption = 'ޭ' then
  begin
    PreviewBox1.Ratio := 20;
    PreviewBox1.FileName := 'Clipboard data';
    PreviewBox1.TabSize := FrameForm.Parameter1['TabSize'];
    PreviewBox1.LineNumber := FrameForm.Parameter1['LineNumber'];
    PreviewBox1.Partition := FrameForm.Parameter1['Partition'];
    PreviewBox1.PartitionGap := FrameForm.Parameter1['PartitionGap'];
    PreviewBox1.PILeftMargin := FrameForm.Parameter1['PILeftMargin'];
    PreviewBox1.PIRightMargin := FrameForm.Parameter1['PIRightMargin'];
    PreviewBox1.PITopMargin := FrameForm.Parameter1['PITopMargin'];
    PreviewBox1.PIBottomMargin := FrameForm.Parameter1['PIBottomMargin'];
    PreviewBox1.PrintOption := FrameForm.Parameter1['PrintOption'];
    PreviewBox1.Font := FrameForm.RichEdit1.Font;
    PreviewBox1.OptionFont := FrameForm.RichEdit1.Font;
    if PreviewBox1.OptionFont.Size > 12 then
      PreviewBox1.OptionFont.Size := 12;
    if FrameForm.RichEdit1.SelLength = 0 then
      PreviewBox1.Text := FrameForm.RichEdit1.Text
    else
      PreviewBox1.Text := FrameForm.RichEdit1.SelText;
    Caption := 'ޭ : ' + IntToStr(PreviewBox1.PageCount) + ' Page';
    if PreviewBox1.PageCount <> 1 then
      Caption := Caption + 's';
    Caption := Caption + ' ( ' + IntToStr(PreviewBox1.PaperCount) + '  )';
  end
  else
  begin
    PreviewBox1.Ratio := 40;
    Button2.Hint := '܂B';
    PreviewBox1.FileName := '';
    PreviewBox1.TabSize := FrameForm.Parameter1['TabSize'];
    PreviewBox1.PILeftMargin := FrameForm.Parameter1['PILeftMargin'];
    PreviewBox1.PIRightMargin := FrameForm.Parameter1['PIRightMargin'];
    PreviewBox1.PITopMargin := FrameForm.Parameter1['PITopMargin'];
    PreviewBox1.PIBottomMargin := FrameForm.Parameter1['PIBottomMargin'];
    PreviewBox1.PrintOption := poFileName;
    PreviewBox1.Font := FrameForm.RichEdit1.Font;
    PreviewBox1.DispPaperInfo;
  end;
  CheckButtons;
end;

end.
